<template lang="pug">
div
	q-breadcrumbs(gutter="sm").q-mb-lg
		q-breadcrumbs-el(icon="home" to="/")
		q-breadcrumbs-el(label="Кухня" to="/kitchen")
		q-breadcrumbs-el(label="Блюда" to="/kitchen/dished")
		q-breadcrumbs-el(:label="newItem ? 'Новое блюдо' : 'Редактирование блюда'")

	.inner.q-py-md
		q-form.q-gutter-md(@submit="onSubmit")
			ui-input-text(
				v-model="item.name",
				label="Название блюда",
				required,
				:loading="loading"
				)

			q-editor(
				v-model="item.description",
				label="Описание блюда",
				min-height="5rem",
				lazy-rules
				outlined
				:loading="loading"
				:toolbar="[['bold', 'italic', 'strike', 'underline']]"
				)

			ui-uploader-image(
				v-model="item.visual",
				label="Изображение",
				:rules="[ val => val && val.length > 0 || 'Необходимо добавить изображение ингредиента']"
			)

			collection-dishTypes(v-model="item.dishTypes")

			collection-techMaps(v-model="item.techMaps")

			collection-recipe(
				v-model="item.recipeSteps"
				label="Шаги рецепта"
				required
			)

			q-btn(
				:label="newItem ? 'Добавить блюдо' : 'Сохранить блюдо'",
				type="submit",
				color="primary"
				:loading="loading"
			)


</template>

<script lang="ts">
	import { computed, defineComponent, onMounted, ref } from 'vue'
	import { mapWritableState } from 'pinia'
	import { IDish } from '@/plugins/utils/types'
	import { useRouter } from 'vue-router'
	import UiInputText from '@/components/ui/UiInputText.vue'
	import UiUploaderImage from '@/components/ui/UiUploaderImage.vue'
	import CollectionDishTypes from '@/pages/kitchen/components/CollectionDishTypes.vue'
	import CollectionTechMaps from '@/pages/kitchen/components/CollectionTechMaps.vue'
	import CollectionRecipe from '@/pages/kitchen/components/CollectionRecipe.vue'
	import { useKitchenDishesStore } from '@/pages/kitchen/children/dishes/store'
	import { useQuasar } from 'quasar'

	export default defineComponent({
		name: 'PageKitchenDishesItem',

		props: ['id'],

		components: {
			UiInputText,
			UiUploaderImage,
			CollectionRecipe,
			CollectionDishTypes,
			CollectionTechMaps,
		},

		setup(props) {
			const $q = useQuasar()
			const newItem = ref(props.id === undefined)
			const store = useKitchenDishesStore()
			const router = useRouter()

			onMounted(() => {
				store.getDishById(props.id)
			})

			return {
				newItem,
				loading: computed(() => store.loading),
				async onSubmit() {
					const { id } = (await store.saveDishItem()) as unknown as IDish
					await router.push(`/kitchen/dishes/${id}`)
					$q.notify({
						color: 'positive',
						message: newItem.value ? 'Новое блюдо добавлен' : 'Изменения сохранены',
					})
				},
			}
		},

		computed: {
			...mapWritableState(useKitchenDishesStore, {
				item: 'item',
			}),
		},
	})
</script>
